"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class TumourSample(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "labSampleId",
        "sampleId",
        "tumourId",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_4_1 import participant as participant_1_0_1

        return {
            "phase": participant_1_0_1.Phase,
            "preparationMethod": participant_1_0_1.PreparationMethod,
            "product": participant_1_0_1.Product,
            "programmePhase": participant_1_0_1.ProgrammePhase,
            "source": participant_1_0_1.SampleSource,
            "tissueSource": participant_1_0_1.TissueSource,
            "tumourContent": participant_1_0_1.TumourContent,
            "tumourType": participant_1_0_1.TumourType,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_4_1 import participant as participant_1_0_1

        return {
            "org.gel.models.participant.avro.Phase": participant_1_0_1.Phase,
            "org.gel.models.participant.avro.PreparationMethod": participant_1_0_1.PreparationMethod,
            "org.gel.models.participant.avro.Product": participant_1_0_1.Product,
            "org.gel.models.participant.avro.ProgrammePhase": participant_1_0_1.ProgrammePhase,
            "org.gel.models.participant.avro.SampleSource": participant_1_0_1.SampleSource,
            "org.gel.models.participant.avro.TissueSource": participant_1_0_1.TissueSource,
            "org.gel.models.participant.avro.TumourContent": participant_1_0_1.TumourContent,
            "org.gel.models.participant.avro.TumourType": participant_1_0_1.TumourType,
            "org.gel.models.participant.avro.TumourSample": participant_1_0_1.TumourSample,
        }

    __slots__ = [
        "labSampleId",
        "sampleId",
        "tumourId",
        "TNMStageGrouping",
        "TNMStageVersion",
        "clinicalSampleDateTime",
        "phase",
        "preparationMethod",
        "product",
        "programmePhase",
        "source",
        "tissueSource",
        "tumourContent",
        "tumourSubType",
        "tumourType",
    ]

    def __init__(
        self,
        labSampleId,
        sampleId,
        tumourId,
        TNMStageGrouping=None,
        TNMStageVersion=None,
        clinicalSampleDateTime=None,
        phase=None,
        preparationMethod=None,
        product=None,
        programmePhase=None,
        source=None,
        tissueSource=None,
        tumourContent=None,
        tumourSubType=None,
        tumourType=None,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_0_1.TumourSample model.

        :param labSampleId:
            Lab sample Id
        :type labSampleId: int
        :param sampleId:
            Sample Id (e.g, LP00012645_5GH))
        :type sampleId: str
        :param tumourId:
            Id of each one of the tumors for a participant
        :type tumourId: int
        :param TNMStageGrouping:
            TMN stage grouping
        :type TNMStageGrouping: None | str
        :param TNMStageVersion:
            TMN version
        :type TNMStageVersion: None | str
        :param clinicalSampleDateTime:
            In the format YYYY-MM-DDTHH:MM:SS+0000
        :type clinicalSampleDateTime: None | str
        :param phase:
            Tumor Phase
        :type phase: None | Phase
        :param preparationMethod:
            preparationMethod
        :type preparationMethod: None | PreparationMethod
        :param product:
            Product
        :type product: None | Product
        :param programmePhase:
            gelPhase (eg cruk, brc, cll, iip, main)
        :type programmePhase: None | ProgrammePhase
        :param source:
            Method
        :type source: None | SampleSource
        :param tissueSource:
            Method
        :type tissueSource: None | TissueSource
        :param tumourContent:
            tumourContent
        :type tumourContent: None | TumourContent
        :param tumourSubType:
            Tumor Subtype
        :type tumourSubType: None | str
        :param tumourType:
            tumour Type
        :type tumourType: None | TumourType
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.0.1"
